/**
 * To handle cases where users had data stored without azumio account
 */

azumio_updaterecovery = {};

azumio_updaterecovery.queue = (function(){
	if(!localStorage.getItem("head") || !localStorage.getItem('tail') ){
		localStorage.setItem("head", 0);
		localStorage.setItem("tail",0);
	}
	
	this.head = function(){
		return parseInt(localStorage.getItem("head"));
	}
	
	this.tail = function(){
		return parseInt(localStorage.getItem("tail"));
	}
	
	this.push = function(obj){
		var h = this.head();
		localStorage.setItem("queue."+h, JSON.stringify(obj,null," "));
		localStorage.setItem("head", h+1);
	}
	
	this.peek = function(){
		var t = this.tail();
		var h = this.head();
		if(t>=h)
			return null;
		var cis = localStorage.getItem("queue."+t);
		try{
			var ci = JSON.parse(cis);
		}catch(e){
			this.removeTail();
			return this.peek();
		}
		return ci;
	}
	this.removeTail = function(){
		var t = this.tail();
		var h = this.head();
		if(t>=h)
			return false;
		t = t + 1;
		localStorage.setItem("tail", t);
	}
	
	this.pop = function(){
		var ci = this.peek();
		this.removeTail();
		return ci;
	}
	
	this.all = function(){
		var h = this.head();
		var t = this.tail();
		var q = [];
		while(t<h){
			
				var key = "queue."+(h-1);
				var cis = localStorage.getItem(key);
				
				try{
					var checkin = JSON.parse(cis)
					q.push( checkin );
				}catch(e){}
				
				h = h-1;
			
		}
		return q;
	} 
	return this;
})();

azumio_updaterecovery.recover = function(){
	if( localStorage === azumio.localStorage )
		return;
	
	var data = azumio_updaterecovery.queue.peek();
	while( data != null ){
		azumio.queue.push(data);
		azumio_updaterecovery.queue.removeTail();
		data = azumio_updaterecovery.queue.peek();
	}
}
